<?php

namespace App\Filament\Resources;

use App\Filament\Exports\ItemExporter;
use App\Filament\Imports\ItemImporter;
use App\Filament\Resources\ItemResource\Pages;
use App\Models\Item;
use App\Models\Plant;
use Filament\Actions\Exports\Enums\ExportFormat;
use Filament\Facades\Filament;
use Filament\Forms;
use Filament\Forms\Components\TextInput;
use Filament\Forms\Form;
use Filament\Forms\Get;
use Filament\Resources\Resource;
use Filament\Tables;
use Filament\Tables\Actions\ExportAction;
use Filament\Tables\Actions\ImportAction;
use Filament\Tables\Table;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\SoftDeletingScope;
use Filament\Forms\Components\Section;
use Illuminate\Validation\Rule;

class ItemResource extends Resource
{
    protected static ?string $model = Item::class;

    protected static ?string $navigationIcon = 'heroicon-o-rectangle-stack';

    protected static ?string $navigationGroup = 'Master Entries';

    protected static ?int $navigationSort = 6;

    public static function form(Form $form): Form
    {
        return $form
            ->schema([
                Section::make('')
                    ->schema([
                        Forms\Components\Select::make('plant_id')
                        ->relationship('plant', 'name')
                        ->required()
                        // ->preload()
                        // ->nullable(),
                        ->reactive()
                        ->options(function (callable $get) {
                            $userHas = Filament::auth()->user()->plant_id;
                            return ($userHas && strlen($userHas) > 0) ? Plant::where('id', $userHas)->pluck('name', 'id')->toArray() : Plant::pluck('name', 'id')->toArray();
                        })
                        ->default(function () {
                            return optional(Item::latest()->first())->plant_id;
                        })
                        ->disabled(fn (Get $get) => !empty($get('id')))
                        // ->afterStateUpdated(fn ($set) => $set('block_id', null) & $set('name', null) & $set('start_time', null) & $set('duration', null) & $set('end_time', null))
                        ->afterStateUpdated(function ($state, callable $set, callable $get) {
                            $plantId = $get('plant_id');
                            // Ensure `linestop_id` is not cleared
                            if (!$plantId) {
                                $set('iPlantError', 'Please select a plant first.');
                                return;
                            }
                            else
                            {
                                $set('iPlantError', null);
                            }
                        })
                        ->extraAttributes(fn ($get) => [
                            'class' => $get('iPlantError') ? 'border-red-500' : '',
                        ])
                        ->hint(fn ($get) => $get('iPlantError') ? $get('iPlantError') : null)
                        ->hintColor('danger'),
                    Forms\Components\TextInput::make('category')
                        ->label('Category')
                        ->placeholder('Scan the Category'),
                    Forms\Components\TextInput::make('code')
                        ->required()
                        ->placeholder('Scan the valid code')
                        ->autofocus(true)
                        // ->unique(ignoreRecord: true)
                        ->alphaNum()
                        ->minLength(6)
                        // ->autocapitalize('characters')
                        ->reactive()
                        ->disabled(fn (Get $get) => !empty($get('id')))
                        ->afterStateUpdated(function ($state, callable $set, callable $get) {
                            $code = $get('code');
                            // Ensure `linestop_id` is not cleared
                            if (!$code) {
                                $set('iCodeError', 'Scan the valid code.');
                                return;
                            }
                            else
                            {
                                if (strlen($code) < 6) {
                                    $set('iCodeError', 'Item code must be at least 6 digits.');
                                    return;
                                }
                                else if (!preg_match('/^[a-zA-Z0-9]{6,}$/', $code)) {
                                    $set('code',null);
                                    $set('iCodeError', 'Item code must contain only alpha-numeric characters.');
                                    return;
                                }
                                $set('iCodeError', null);
                            }
                        })
                        ->extraAttributes(fn ($get) => [
                            'class' => $get('iCodeError') ? 'border-red-500' : '',
                        ])
                        ->hint(fn ($get) => $get('iCodeError') ? $get('iCodeError') : null)
                        ->hintColor('danger')
                        ->rule(function (callable $get) {
                            return Rule::unique('items', 'code')
                                ->where('plant_id', $get('plant_id'))
                                ->ignore($get('id')); // Ignore current record during updates
                        }),
                    Forms\Components\TextInput::make('hourly_quantity')
                        ->required()
                        ->label('Hourly Quantity')
                        ->placeholder('Scan the valid quantity')
                        ->integer()
                        ->default(1)
                        ->minValue(1)
                        ->reactive()
                        ->afterStateUpdated(function ($state, callable $set, callable $get) {
                            $hourQuan = $get('hourly_quantity');
                            // Ensure `linestop_id` is not cleared
                            if (!$hourQuan) {
                                $set('iHourQuanError', 'Scan the valid hourly quantity.');
                                return;
                            }
                            else
                            {
                                if (!preg_match('/^[0-9]{1,}$/', $hourQuan)) {
                                    $set('hourly_quantity',null);
                                    $set('iHourQuanError', 'Quantity must be integer value.');
                                    return;
                                }
                                $set('iHourQuanError', null);
                            }
                        })
                        ->extraAttributes(fn ($get) => [
                            'class' => $get('iHourQuanError') ? 'border-red-500' : '',
                        ])
                        ->hint(fn ($get) => $get('iHourQuanError') ? $get('iHourQuanError') : null)
                        ->hintColor('danger'),
                    Forms\Components\TextInput::make('uom')
                        ->required()
                        ->label('Unit of Measure')
                        ->placeholder('Scan the valid uom'),

                    Forms\Components\TextInput::make('description')
                        ->placeholder('Scan the valid description')
                        ->required()
                        ->minLength(5)
                        ->columnSpan(['default' => 1, 'sm' => 1]),
                        // ->columnSpanFull(),
                    Forms\Components\TextInput::make('id')
                        ->hidden()
                        ->readOnly(),
                    ])
                    ->columns(3),
            ]);
    }

    public static function table(Table $table): Table
    {
        return $table
            ->columns([
                // Tables\Columns\TextColumn::make('id')
                //     ->label('ID')
                //     ->numeric()
                //     ->sortable(),
                Tables\Columns\TextColumn::make('No.')
                    ->label('No.')
                    // ->getStateUsing(fn ($record, $livewire, $column, $rowLoop) => $rowLoop->iteration),
                    ->getStateUsing(function ($record, $livewire, $column, $rowLoop) {
                        $paginator = $livewire->getTableRecords();
                        $perPage = method_exists($paginator, 'perPage') ? $paginator->perPage() : 10;
                        $currentPage = method_exists($paginator, 'currentPage') ? $paginator->currentPage() : 1;
                        return ($currentPage - 1) * $perPage + $rowLoop->iteration;
                    }),
                Tables\Columns\TextColumn::make('plant.name')
                    ->label('Plant')
                    ->alignCenter()
                    ->sortable()
                    ->searchable(),
                Tables\Columns\TextColumn::make('category')
                    ->label('Category')
                    ->alignCenter()
                    ->sortable()
                    ->searchable(),
                Tables\Columns\TextColumn::make('code')
                    ->label('Item Code')
                    ->alignCenter()
                    ->sortable()
                    ->searchable(),
                Tables\Columns\TextColumn::make('description')
                    ->label('Description')
                    ->alignCenter()
                    ->sortable()
                    ->searchable(),
                Tables\Columns\TextColumn::make('hourly_quantity')
                    ->label('Hourly Quantity')
                    ->numeric()
                    ->alignCenter()
                    ->sortable(),
                Tables\Columns\TextColumn::make('uom')
                    ->label('Unit of Measure')
                    ->alignCenter()
                    ->sortable(),
                Tables\Columns\TextColumn::make('created_at')
                    ->label('Created At')
                    ->dateTime()
                    ->alignCenter()
                    ->sortable(),
                Tables\Columns\TextColumn::make('updated_at')
                    ->label('Updated At')
                    ->dateTime()
                    ->alignCenter()
                    ->sortable()
                    ->toggleable(isToggledHiddenByDefault: true),
                Tables\Columns\TextColumn::make('deleted_at')
                    ->label('Deleted At')
                    ->dateTime()
                    ->alignCenter()
                    ->sortable()
                    ->toggleable(isToggledHiddenByDefault: true),
            ])
            ->filters([
                Tables\Filters\TrashedFilter::make(),
            ])
            ->actions([
                Tables\Actions\ViewAction::make(),
                Tables\Actions\EditAction::make(),
            ])
            ->bulkActions([
                Tables\Actions\BulkActionGroup::make([
                    Tables\Actions\DeleteBulkAction::make(),
                    Tables\Actions\ForceDeleteBulkAction::make(),
                    Tables\Actions\RestoreBulkAction::make(),
                ]),
            ])
            ->headerActions([
                ImportAction::make()
                    ->importer(ItemImporter::class)
                    ->visible(function() {
                        return Filament::auth()->user()->can('view import item');
                    }),
                    // ->maxRows(100000),
                ExportAction::make()
                    // ->columnMapping(true)
                    // ->label('Export')
                    // ->fileName("Items Report " . date('Y-m-d H:i:s'))
                    ->exporter(ItemExporter::class)
                    ->visible(function() {
                        return Filament::auth()->user()->can('view export item');
                    }),
                    // ->formats([
                    //     ExportFormat::Xlsx,
                    //     ExportFormat::Csv,
                    // ]),
            ]);
    }

    public static function getRelations(): array
    {
        return [
            //
        ];
    }

    public static function getPages(): array
    {
        return [
            'index' => Pages\ListItems::route('/'),
            'create' => Pages\CreateItem::route('/create'),
            'view' => Pages\ViewItem::route('/{record}'),
            'edit' => Pages\EditItem::route('/{record}/edit'),
        ];
    }

    public static function getEloquentQuery(): Builder
    {
        return parent::getEloquentQuery()
            ->withoutGlobalScopes([
                SoftDeletingScope::class,
            ]);
    }
}
